﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;
namespace SilenceTest
{

    class Light
    {
        public int Level;
        public int Hue;
        public int Sat;
        public bool bOn;
        public bool bupdate;
        public UInt16 cAddr;
        public byte cEndpoint;
        public int ProfileId;
        public int DeviceID;
        public string Name;
        public string SNID;
        public byte[] ieee;
        public Light()
        {
            Level = 0;
            Hue = 0;
            Sat = 0;
            bOn = false;
            bupdate = false;
            cAddr = 0;
            cEndpoint = 0;
            ieee = new byte[8];
        }
        public void SetLevel(int level)
        {
            Level = level;
            bupdate = true;
        }
    }
    class Box
    {
        private const int SRPC_CMD_ID_POS = 0;
        private const int SRPC_CMD_LEN_POS = 1;

        //SRPC CMD ID's	
        //define the outgoing RPSC command ID's
        private const byte RPCS_NEW_ZLL_DEVICE = (byte)0x0001;
        private const byte RPCS_DEV_ANNCE = (byte)0x0002;
        private const byte RPCS_SIMPLE_DESC = (byte)0x0003;
        private const byte RPCS_TEMP_READING = (byte)0x0004;
        private const byte RPCS_POWER_READING = (byte)0x0005;
        private const byte RPCS_PING = (byte)0x0006;
        private const byte RPCS_GET_DEV_STATE_RSP = (byte)0x0007;
        private const byte RPCS_GET_DEV_LEVEL_RSP = (byte)0x0008;
        private const byte RPCS_GET_DEV_HUE_RSP = (byte)0x0009;
        private const byte RPCS_GET_DEV_SAT_RSP = (byte)0x000a;
        private const byte RPCS_ADD_GROUP_RSP = (byte)0x000b;
        private const byte RPCS_GET_GROUP_RSP = (byte)0x000c;
        private const byte RPCS_ADD_SCENE_RSP = (byte)0x000d;
        private const byte RPCS_GET_SCENE_RSP = (byte)0x000e;


        //define incoming RPCS command ID's
        private const byte RPCS_CLOSE = (byte)0x80;
        private const byte RPCS_GET_DEVICES = (byte)0x81;
        private const byte RPCS_SET_DEV_STATE = (byte)0x82;
        private const byte RPCS_SET_DEV_LEVEL = (byte)0x83;
        private const byte RPCS_SET_DEV_COLOR = (byte)0x84;
        private const byte RPCS_GET_DEV_STATE = (byte)0x85;
        private const byte RPCS_GET_DEV_LEVEL = (byte)0x86;
        private const byte RPCS_GET_DEV_HUE = (byte)0x87;
        private const byte RPCS_GET_DEV_SAT = (byte)0x88;
        private const byte RPCS_BIND_DEVICES = (byte)0x89;
        private const byte RPCS_GET_THERM_READING = (byte)0x8a;
        private const byte RPCS_GET_POWER_READING = (byte)0x8b;
        private const byte RPCS_DISCOVER_DEVICES = (byte)0x8c;
        private const byte RPCS_SEND_ZCL = (byte)0x8d;
        private const byte RPCS_GET_GROUPS = (byte)0x8e;
        private const byte RPCS_ADD_GROUP = (byte)0x8f;
        private const byte RPCS_GET_SCENES = (byte)0x90;
        private const byte RPCS_STORE_SCENE = (byte)0x91;
        private const byte RPCS_RECALL_SCENE = (byte)0x92;
        private const byte RPCS_IDENTIFY_DEVICE = (byte)0x93;
        private const byte RPCS_CHANGE_DEVICE_NAME = (byte)0x94;   

        public ulong snid;
        public string ipaddr;
        public Socket clientSocket=null;
        public Light[] l1;
        public volatile bool bRun;
        private byte[] snidbyte;
        Thread recthread;
        Thread sedthread;

        public Box()
        {
            snidbyte = new byte[4];
        }

        public void ThreadStart()
        {
            byte[] data = new byte[1024];
            int recv;
            int bytesRead = 0;
            int bytesProcessed = 0;
            sendgetdev();
            while (bRun)
            {
                try
                {
                    recv = clientSocket.Receive(data);
                    if (recv > 2)
                    {
                        bytesRead = recv;
                        bytesProcessed = 0;
                        while (bytesRead > bytesProcessed)
                        {
                            bytesProcessed += rpcsProcessIncoming(data, bytesProcessed);
                            // Log.d("procdata", "len" + len);
                        }
                    }
                }
                catch(Exception e)
                {
                }
            }
        }
        private void sendgetdev()
        {
            if (clientSocket != null)
            {
                getDevices();
            }
        }
    public  void newDevice(int ProfileId, int DeviceId, int NetworkAddr, char EndPoint, byte[] ieee, String deviceName,String deviceSNID)
	{
        int i;
        for (i = 0; i < l1.Length; i++)
        {
            if (l1[i].cAddr == 0)
            {
                l1[i].cAddr = (UInt16)NetworkAddr;
                l1[i].cEndpoint = (byte)EndPoint;
                l1[i].ProfileId = ProfileId;
                l1[i].DeviceID = DeviceId;
                l1[i].Name = deviceName;
                l1[i].SNID = deviceSNID;
                if (l1[i].Name == "")
                    l1[i].Name = l1[i].SNID;
                for (int j = 0; j < 8; j++)
                {
                    l1[i].ieee[j] = ieee[j];
                }
                break;
            }
        }
	}
    public int rpcsProcessIncoming(byte[] msg, int msgPtr)
        {
            int msgLen;
            int msgoldstart;
            msgoldstart = msgPtr;
            switch (msg[msgPtr + SRPC_CMD_ID_POS])
            {

                case RPCS_NEW_ZLL_DEVICE:
                    {
                        int profileId = 0, deviceId = 0, nwkAddr = 0;
                        char endPoint;
                        String deviceName = "";
                        String deviceSN = "";
                        byte[] ieee = new byte[8];


                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;
                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the NwkAddr
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int nwkAddrTemp = (msg[msgPtr] & 0xff);
                            nwkAddr += (nwkAddrTemp << (8 * i));
                        }
                        //Get the EndPoint
                        endPoint = (char)msg[msgPtr++];

                        //Get the ProfileId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int profileIdTemp = (msg[msgPtr] & 0xff);
                            profileId += (profileIdTemp << (8 * i));
                        }

                        //Get the DeviceId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int deviceIdTemp = (msg[msgPtr] & 0xff);
                            deviceId += (deviceIdTemp << (8 * i));
                        }

                        //index passed version
                        msgPtr++;

                        //index passed device name
                        int nameSize = msg[msgPtr++];
                        if (nameSize > 0)
                        {
                            char[] device1 = new char[nameSize];
                            for (int i = 0; i < nameSize; i++)
                            {
                                //deviceName += (char) msg[msgPtr++];
                                device1[i] = (char)msg[msgPtr++];
                            }
                            //try
                            {
                                deviceName = new String(device1,0,nameSize);
                            }
                            /*catch (UnsupportedEncodingException e)
                            {
                                // TODO Auto-generated catch block
                                e.printStackTrace();
                            }*/
                        }
                        msgPtr += nameSize;

                        //index passed status
                        msgPtr++;

                        //copy IEEE Addr
                        for (int i = 0; i < 8; i++)
                        {
                            ieee[i] = msg[msgPtr++];
                        }
                        if ((msgPtr - msgoldstart + 2) < msgLen)
                        {
                            int snSize = msg[msgPtr++];
                            if ((snSize > 0) && (snSize < 64))
                            {
                                char[] device2 = new char[snSize];
                                for (int i = 0; i < snSize; i++)
                                {
                                    //deviceName += (char) msg[msgPtr++];
                                    device2[i] = (char)msg[msgPtr++];
                                }

                                {
                                    deviceSN = new String(device2,0,snSize);
                                }

                            }
                        }
                        newDevice(profileId, deviceId, nwkAddr, endPoint, ieee, deviceName, deviceSN);

                        break;
                    }
                case RPCS_ADD_GROUP_RSP:
                    {
                        short groupId = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the GroupId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int groupIdTemp = (msg[msgPtr] & 0xff);
                            groupId +=(short) (groupIdTemp << (8 * i));
                        }
                        /*
                        String groupNameStr = new String(msg, msgPtr + 1, msg[msgPtr], Charset.defaultCharset());

                        List<ZigbeeGroup> groupList = ZigbeeAssistant.getGroups();
                        //find the group
                        for (int i = 0; i < groupList.size(); i++)
                        {
                            if (groupNameStr.equals(groupList.get(i).getGroupName()))
                            {
                                groupList.get(i).setGroupId(groupId);
                                groupList.get(i).setStatus(ZigbeeGroup.groupStatusActive);
                                break;
                            }
                        }*/
                        break;
                    }

                case RPCS_GET_GROUP_RSP:
                    {
                        short groupId = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the groupId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int groupIdTemp = (msg[msgPtr] & 0xff);
                            groupId +=(short) (groupIdTemp << (8 * i));
                        }
                        /*
                        String groupNameStr = new String(msg, msgPtr + 1, msg[msgPtr], Charset.defaultCharset());

                        ZigbeeAssistant.newGroup(groupNameStr, groupId, ZigbeeGroup.groupStatusActive);
                        */
                        break;
                    }

                case RPCS_ADD_SCENE_RSP:
                    {
                        short groupId = 0;
                        byte sceneId = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the GroupId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int groupIdTemp = (msg[msgPtr] & 0xff);
                            groupId += (short)(groupIdTemp << (8 * i));
                        }

                        //Get the sceneId
                        sceneId = (byte)msg[msgPtr++];
                        /*
                        String sceneNameStr = new String(msg, msgPtr + 1, msg[msgPtr], Charset.defaultCharset());

                        List<ZigbeeScene> sceneList = ZigbeeAssistant.getScenes();
                        //find the scene
                        for (int i = 0; i < sceneList.size(); i++)
                        {
                            if (sceneNameStr.equals(sceneList.get(i).getSceneName()) && (groupId == sceneList.get(i).getGroupId()))
                            {
                                sceneList.get(i).setSceneId(sceneId);
                                sceneList.get(i).setStatus(ZigbeeScene.sceneStatusActive);
                                break;
                            }
                        }*/
                        break;
                    }

                case RPCS_GET_SCENE_RSP:
                    {
                        short groupId = 0;
                        byte sceneId = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the groupId
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int groupIdTemp = (msg[msgPtr] & 0xff);
                            groupId += (short)(groupIdTemp << (8 * i));
                        }

                        //Get the sceneId
                        sceneId = (byte)msg[msgPtr++];
                        /*
                        String sceneNameStr = new String(msg, msgPtr + 1, msg[msgPtr], Charset.defaultCharset());

                        ZigbeeAssistant.newScene(sceneNameStr, groupId, sceneId, ZigbeeScene.sceneStatusActive);
                        */
                        break;
                    }
                case RPCS_GET_DEV_STATE_RSP:
                    {
                        short nwkAddr = 0;
                        byte endPoint = 0;
                        byte state = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the nwkAddr
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int nwkAddrTemp = (msg[msgPtr] & 0xff);
                            nwkAddr += (short)(nwkAddrTemp << (8 * i));
                        }

                        //Get the EP
                        endPoint = (byte)msg[msgPtr++];

                        //Get the state
                        state = (byte)msg[msgPtr++];

                        /*
                        List<ZigbeeDevice> devList = ZigbeeAssistant.getDevices();
                        //find the device
                        for (int i = 0; i < devList.size(); i++)
                        {
                            if ((((short)devList.get(i).NetworkAddr) == nwkAddr) && (devList.get(i).EndPoint == endPoint))
                            {
                                devList.get(i).setCurrentState(state);
                                break;
                            }
                        }*/
                        break;
                    }
                case RPCS_GET_DEV_LEVEL_RSP:
                    {
                        short nwkAddr = 0;
                        byte endPoint = 0;
                        byte level = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the nwkAddr
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int nwkAddrTemp = (msg[msgPtr] & 0xff);
                            nwkAddr += (short)(nwkAddrTemp << (8 * i));
                        }

                        //Get the EP
                        endPoint = (byte)msg[msgPtr++];

                        //Get the state
                        level = (byte)msg[msgPtr++];

                        /*
                        List<ZigbeeDevice> devList = ZigbeeAssistant.getDevices();
                        //find the device
                        for (int i = 0; i < devList.size(); i++)
                        {
                            if ((((short)devList.get(i).NetworkAddr) == nwkAddr) && (devList.get(i).EndPoint == endPoint))
                            {
                                devList.get(i).setCurrentLevel(level);
                                break;
                            }
                        }*/
                        break;
                    }
                case RPCS_GET_DEV_HUE_RSP:
                    {
                        short nwkAddr = 0;
                        byte endPoint = 0;
                        byte hue = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the nwkAddr
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int nwkAddrTemp = (msg[msgPtr] & 0xff);
                            nwkAddr += (short)(nwkAddrTemp << (8 * i));
                        }

                        //Get the EP
                        endPoint = (byte)msg[msgPtr++];

                        //Get the state
                        hue = (byte)msg[msgPtr++];

                        /*
                        List<ZigbeeDevice> devList = ZigbeeAssistant.getDevices();
                        //find the device
                        for (int i = 0; i < devList.size(); i++)
                        {
                            if ((((short)devList.get(i).NetworkAddr) == nwkAddr) && (devList.get(i).EndPoint == endPoint))
                            {
                                devList.get(i).setCurrentHue(hue);
                                break;
                            }
                        }*/
                        break;
                    }
                case RPCS_GET_DEV_SAT_RSP:
                    {
                        short nwkAddr = 0;
                        byte endPoint = 0;
                        byte sat = 0;
                        msgLen = msg[msgPtr + SRPC_CMD_LEN_POS] + 2;

                        //index passed len and cmd ID
                        msgPtr += 2;

                        //Get the nwkAddr
                        for (int i = 0; i < 2; i++, msgPtr++)
                        {
                            //java does not support unsigned so use a bigger container to avoid conversion issues
                            int nwkAddrTemp = (msg[msgPtr] & 0xff);
                            nwkAddr += (short)(nwkAddrTemp << (8 * i));
                        }

                        //Get the EP
                        endPoint = (byte)msg[msgPtr++];

                        //Get the state
                        sat = (byte)msg[msgPtr++];
                        /*

                        List<ZigbeeDevice> devList = ZigbeeAssistant.getDevices();
                        //find the device
                        for (int i = 0; i < devList.size(); i++)
                        {
                            if ((((short)devList.get(i).NetworkAddr) == nwkAddr) && (devList.get(i).EndPoint == endPoint))
                            {
                                devList.get(i).setCurrentSat(sat);
                                break;
                            }
                        }*/
                        break;
                    }

                default:
                    {
                        msgLen = 0;
                        break;
                    }
            }

            return msgLen;
        }
        public  void sendSrpc(byte[] msg)
        {
            int j = msg.Length;
            byte[] bt1 = new byte[j + 7];
            bt1[0] = (byte)((j + 7) & 0xff);
            bt1[1] = (byte)(((j + 7) & 0xff00) / 0x100);
            for (int i = 0; i < 4; i++)
            {
                bt1[i + 2] = snidbyte[i];
            }
            bt1[6] = (byte)0xfe;
            for (int i = 0; i < j; i++)
            {
                bt1[7 + i] = msg[i];
            }
            
                try
                {
                    clientSocket.Send(bt1, SocketFlags.DontRoute );
                    Thread.Sleep(5);
                }
                catch (Exception e) { }

        }
        public  void getDevices()
        {
            byte[] msg = new byte[2];

            //set SRPC len and CMD ID
            msg[SRPC_CMD_ID_POS] = RPCS_GET_DEVICES;
            msg[SRPC_CMD_LEN_POS] = 0;

            sendSrpc(msg);
        }
        public  void setDeviceState(ushort nwkAddr, byte AddrMode, byte endPoint, bool state)
        {
            byte[] msg = new byte[15];
            byte msgIdx;

            //set SRPC len and CMD ID
            msg[SRPC_CMD_ID_POS] = RPCS_SET_DEV_STATE;
            msg[SRPC_CMD_LEN_POS] = 13;

            //set ptr to point to data
            msgIdx = 2;

            //dstAddr.addrMode
            msg[msgIdx++] = (byte)AddrMode;
            //set afAddrMode_t nwk address		
            msg[msgIdx++] = (byte)(nwkAddr & 0xFF);
            msg[msgIdx++] = (byte)((nwkAddr & 0xFF00) >> 8);
            //pad for an ieee addr size;
            msgIdx += 6;
            //set Ep
            msg[msgIdx++] = (byte)endPoint;
            //pad out pan ID
            msgIdx += 2;

            //set State
            if (state)
            {
                msg[msgIdx++] = (byte)1;
            }
            else
            {
                msg[msgIdx++] = (byte)0;
            }

            sendSrpc(msg);

        }

        public  void setDeviceLevel(ushort nwkAddr, byte AddrMode, byte endPoint, byte level, short transitionTime)
        {
            byte[] msg = new byte[17];
            byte msgIdx;

            //set SRPC len and CMD ID
            msg[SRPC_CMD_ID_POS] = RPCS_SET_DEV_LEVEL;
            msg[SRPC_CMD_LEN_POS] = 15;

            //set ptr to point to data
            msgIdx = 2;

            //dstAddr.addrMode
            msg[msgIdx++] = (byte)AddrMode;
            //set afAddrMode_t nwk address		
            msg[msgIdx++] = (byte)(nwkAddr & 0xFF);
            msg[msgIdx++] = (byte)((nwkAddr & 0xFF00) >> 8);
            //pad for an ieee addr size;
            msgIdx += 6;
            //set Ep
            msg[msgIdx++] = (byte)endPoint;
            //pad out pan ID
            msgIdx += 2;

            //set level
            msg[msgIdx++] = (byte)level;

            //set transitionTime
            msg[msgIdx++] = (byte)transitionTime;

            sendSrpc(msg);
        }

        public  void setDeviceColor(ushort nwkAddr, byte AddrMode, byte endPoint, byte hue, byte saturation, short transitionTime)
        {
            byte[] msg = new byte[18];
            byte msgIdx;

            //set SRPC len and CMD ID
            msg[SRPC_CMD_ID_POS] = RPCS_SET_DEV_COLOR;
            msg[SRPC_CMD_LEN_POS] = 16;

            //set ptr to point to data
            msgIdx = 2;

            //dstAddr.addrMode
            msg[msgIdx++] = (byte)AddrMode;
            //set afAddrMode_t nwk address		
            msg[msgIdx++] = (byte)(nwkAddr & 0xFF);
            msg[msgIdx++] = (byte)((nwkAddr & 0xFF00) >> 8);
            //pad for an ieee addr size;
            msgIdx += 6;
            //set Ep
            msg[msgIdx++] = (byte)endPoint;
            //pad out pan ID
            msgIdx += 2;

            //set level
            msg[msgIdx++] = (byte)hue;

            //set saturation
            msg[msgIdx++] = (byte)saturation;

            //set transitionTime
            msg[msgIdx++] = (byte)transitionTime;

            sendSrpc(msg);
        }
        public bool Disc()
        {
            bRun = false;
            if (recthread != null)
            {
                recthread.Abort();
            }
            if (sedthread != null)
            {
                sedthread.Abort();
            } 
            clientSocket.Close();
            return true;
        }
        public bool Connect(string snid,string ipaddr)
        {
            //return true;
            IPAddress ip = IPAddress.Parse(ipaddr);
            UInt32 usn = Convert.ToUInt32(snid, 16);
            snidbyte[0] =(byte)( usn % 256);
            snidbyte[1] = (byte)((usn/256) % 256);
            snidbyte[2] = (byte)((usn/256/256) % 256);
            snidbyte[3] = (byte)(usn/256/256/256);
            

            clientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                clientSocket.Connect(new IPEndPoint(ip, 8001)); //配置服务器IP与端口  
            }
            catch
            {
                return false;
            }
            l1 = new Light[40];
            for (int j = 0; j <40; j++)
            {
                l1[j] = new Light();
            }
            bRun = true;
            recthread = new Thread(ThreadStart);
            recthread.Start();

            //sedthread = new Thread(ThreadStart2);
            //sedthread.Start();
            return true;
        }
       
 
        public void SetHue(float vol)
        {
            setDeviceColor(0x02, (byte)1, 0x0B, (byte)(vol - 256.0f), (byte)255, 20);
        }
        public void Reset2Def()
        {
            int i;
            for (i = 0; i < l1.Length; i++)
            {
                if (l1[i].cAddr != 0)
                {
                    l1[i].Level = 255 * 3 / 10;
                    setDeviceLevel(l1[i].cAddr, (byte)2, (byte)l1[i].cEndpoint, (byte)l1[i].Level, 1);
                    Thread.Sleep(300);
                }
            }

        }
        
    }
}
